﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private URL As String = "http://127.0.0.1:8888"
End Sub

Public Sub Initialize
	
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
End Sub

Private Sub BtnPUT_Click
	SendData("PUT")
End Sub

Private Sub BtnPOST_Click
	SendData("POST")
End Sub

Private Sub BtnGET_Click
	SendData("GET")
End Sub

Private Sub BtnDELETE_Click
	SendData("DELETE")
End Sub

Sub SendData (Method As String)
	Dim j As HttpJob
	Dim strError As String
	Dim strData As String
	Try
		Dim Path As String = "/test"
		Dim Link As String = $"${URL}${Path}"$
		'Log("Link:" & Link)
		
		j.Initialize("", Me)
		Select Case Method.ToUpperCase
			Case "POST"
				Dim Map1 As Map = CreateMap("key1":"ABCD", "key2":1234)
				Dim jsn As String = Map2Json(Map1)
				j.PostString(Link, jsn)
			Case "PUT"
				Dim Map1 As Map = CreateMap("key1":"ABCD", "key2":1234)
				Dim jsn As String = Map2Json(Map1)
				j.PutString(Link, jsn)
			Case "DELETE"
				j.Delete2(Link, Array As String("key1", "ABCD", "key2", "1234"))
			Case Else ' GET
				j.Download2(Link, Array As String("key1", "ABCD", "key2", "1234"))
		End Select
		
		Wait For (j) JobDone(j As HttpJob)
		If j.Success Then
			strData = j.GetString
			Log(strData)
			xui.MsgboxAsync(strData, "OK")
		Else
			strError = j.ErrorMessage
			j.Release
			Log(strError)
			xui.MsgboxAsync(strError, "Error")
		End If
	Catch
		j.Release
		Log(LastException.Message)
		xui.MsgboxAsync(LastException.Message, "Exception")
	End Try
End Sub

Sub Map2Json(M As Map) As String
	Dim gen As JSONGenerator
	gen.Initialize(M)
	Return gen.ToString
End Sub